#include "geoclass.cpp"
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <alloc.h>

/**************************** declarations *****************************/
float rel_ang(float x1, float y1, float x2, float y2);
char buttonpressed(void);
int mousex(void);
int mousey(void);
void initmouse(void);
char sgn(int val);
void initscrn(char mode);
unsigned char csmode(void);
void putpixel(int x, int y, unsigned char colour, char mode);
void calcrotarea(int centerx, int centery, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, int *x1, int *y1, int *x2, int *y2);
void rotput(int centerx, int centery, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, char mode);
void erase(int x1, int y1, int x2, int y2, int xoffset, int yoffset, unsigned char far *pic);
unsigned char *loadptrpic(unsigned char *filename);

void play(void);
/**************************** definitions ******************************/
#define pi 3.141592653589793238462643383279502884197169399375105820974944
#define numchunks 15
#define chunksize 20
#define update_screen(){_fmemcpy(mcgamem, vmem, 64000);}

/************************** Global Variables ***************************/
unsigned char far *mcgamem = (unsigned char far *)0xA0000000, far *vmem;


void main(void){
	unsigned char memgood = 1;

	vmem = (unsigned char far *)farmalloc(64000);
	if(vmem){
		play();
		farfree(vmem);
	}else memgood = 0;

	if(!memgood) printf("Insufficient memory.\n");

}
/*
class segmenttype{
	public:
		float x, y, oldx, oldy, ang, oldang;
};
*/
typedef struct{
	float x, y, oldx, oldy, ang, oldang;
}segmenttype;

void play(void){
	segmenttype segment[numchunks];
	unsigned char *segpic,  smode, *backg;
	int a, b, n, x1, y1, x2, y2;
	float slope, dist;

	segpic = loadptrpic("wormseg.pic");
	backg = loadptrpic("backg1.pic");
	smode = csmode();
	initscrn(0x13);
	initmouse();

	a = mousex();
	b = mousey();

	for(n = 0; n < numchunks; n++){
		segment[n].x = a + n * (sqrt((chunksize * chunksize) / 2));
		segment[n].y = b + n * (sqrt((chunksize * chunksize) / 2));
		segment[n].ang = rel_ang(0, 0, 1, 1);
	}
	for(n = 1; n < numchunks; n++)
		rotput(segment[n].x, segment[n].y, segpic[0] >> 1, segpic[1] >> 1, segment[n].ang, 1, segpic, 1);

	while(buttonpressed());

	erase(0, 0, 319, 199, 0, 0, backg);
	while(!buttonpressed()){

		//if(segment[0].x != mousex() || segment[0].y != mousey()){
			segment[0].oldx = segment[0].x;
			segment[0].oldy = segment[0].y;
			segment[0].x = mousex();
			segment[0].y = mousey();

			for(n = 1; n < numchunks; n++){
				dist = sqrt(abs((segment[n].x - segment[n - 1].x) * (segment[n].x - segment[n - 1].x) +
								(segment[n].y - segment[n - 1].y) * (segment[n].y - segment[n - 1].y)));

				if(dist){
					slope = (float)chunksize / dist;
					segment[n].oldx = segment[n].x;
					segment[n].oldy = segment[n].y;
					segment[n].oldang = segment[n].ang;

					segment[n].x = - slope * (segment[n - 1].x - segment[n].x) + segment[n - 1].x;
					segment[n].y = - slope * (segment[n - 1].y - segment[n].y) + segment[n - 1].y;
					segment[n].ang = rel_ang(segment[n].x, segment[n].y, segment[n - 1].x, segment[n - 1].y);
				}

			}

			for(n = 1; n < numchunks; n++){
				calcrotarea(segment[n].oldx, segment[n].oldy, segpic[0] >> 1, segpic[1] >> 1, segment[n].oldang, 1, segpic, &x1, &y1, &x2, &y2);
				erase(x1, y1, x2, y2, 0, 0, backg);
			}

			for(n = numchunks - 1; n > 0; n--)
				rotput(segment[n].x, segment[n].y, segpic[0] >> 1, segpic[1] >> 1, segment[n].ang, 1, segpic, 4);

			update_screen();
		//}
	}
	free(segpic);
	free(backg);
	initscrn(smode);
	while(buttonpressed());

}

float rel_ang(float x1, float y1, float x2, float y2){
	float hyp, alpha, deltax, deltay;
	deltax = x2 - x1;
	deltay = y2 - y1;
	hyp = sqrt(deltax * deltax + deltay * deltay);

	/********* figure out the value for alpha *********/
	if(y2 == y1){
		alpha = pi / 2;
		if(x2 < x1) alpha = 3 * pi / 2;
	}else if(x2 == x1){
		alpha = 0;
		if(y2 > y1) alpha = pi;

	}else if(x2 > x1){
		if(y2 < y1)
			alpha = asin(deltay / hyp) + pi / 2;
		else if(y2 > y1)
			alpha = asin(deltay / hyp) + pi / 2;
	}else if(x2 < x1){
		if(y2 < y1)
			alpha = acos(deltay / hyp) + pi;
		else if(y2 > y1)
			alpha = acos(deltay / hyp) + pi;
	}

	return alpha;
}

/**************************** Mouse I/O *****************************/
char buttonpressed(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, bx
	}
	return returnval;
}

int mousex(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, cx
	}
	return returnval >> 1;
}

int mousey(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, dx
	}
	return returnval;

}

void initmouse(void){
	asm{
		mov ax, 0
		int 0x33
	}
}


/****************************** Misc ******************************/
char sgn(int val){
	if(val > 0) return 1;
	return -(val < 0);
}

/****************************** Graphics ******************************/
void initscrn(char mode){
	asm{
		mov ah, 0
		mov al, mode
		int 0x10
	}
}

unsigned char csmode(void){
	unsigned char returnval;
	asm{
		mov ah, 0xF
		int 0x10
		mov returnval, al
	}
	return returnval;
}

void putpixel(int x, int y, unsigned char colour, char mode){
	if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
		switch(mode){
			case 0: vmem[(y << 8) + (y << 6) + x]  = colour; break;
			case 1: vmem[(y << 8) + (y << 6) + x] ^= colour; break;
			case 2: vmem[(y << 8) + (y << 6) + x] |= colour; break;
			case 3: vmem[(y << 8) + (y << 6) + x] &= colour; break;
			case 4:
				if(colour) vmem[(y << 8) + (y << 6) + x] = colour;
				break;
			case 5:
				if(!vmem[(y << 8) + (y << 6) + x])
					vmem[(y << 8) + (y << 6) + x] = colour;
				break;
			case 6: vmem[(y << 8) + (y << 6) + x] += colour; break;
		}
}

void calcrotarea(int centerx, int centery, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, int *x1, int *y1, int *x2, int *y2){
	const int xsize = pic[0], ysize = pic[1];
	int n, tmp, px[4], py[4];
	const int SINE = sin(ang) * 256 * (scale + !scale);
	const int COSINE = cos(ang) * 256 * (scale + !scale);

	scale += !scale;   /**** prevents division by zero ******/

	px[2] = px[0] = -xoffset;
	py[1] = py[0] = -yoffset;
	px[1] = px[3] = px[0] + xsize;
	py[2] = py[3] = py[0] + ysize;

	for(n = 0; n < 4; n++){
		tmp = (px[n] * COSINE - py[n] * SINE) >> 8;
		py[n] = (px[n] * SINE + py[n] * COSINE) >> 8;
		px[n] = tmp;
		px[n] += centerx;
		py[n] += centery;
	}
	*x1 = *x2 = px[0];
	*y1 = *y2 = py[0];
	for(n = 1; n < 4; n++){
		if(px[n] < *x1) *x1 = px[n];
		if(px[n] > *x2) *x2 = px[n];
		if(py[n] < *y1) *y1 = py[n];
		if(py[n] > *y2) *y2 = py[n];
	}
}

void rotput(int centerx, int centery, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, char mode){
/***
	As !!UUUUUUGGGGGLLLLLLYYYYYYY!! as this is with the case structure around
	the for loops - rather than vice versa - it's much faster, which is an
	absolute necessity.

	The chunks of code defined here at the top of the function are defined
	so as to make the case structure more ledgible, as these are both
	used in each case.

	Please note: The braces around each asm statement in the second definition
	are there because without them, asm requires a newline character, which
	I can't add as part of the #define.
***/


#define HANDLE_MATH_IN_X_LOOP 					\
	deltax = x - centerx;						\
	rotx = deltax * COSINE2 - deltaymulSINE2;	\
	roty = deltax * SINE2 + deltaymulCOSINE2;	\
	rotx >>= 8;									\
	roty >>= 8;									\
	rotx += xoffset;							\
	roty += yoffset;

#define HANDLE_MATH_IN_Y_LOOP 			\
	asm{mov ax, y}						\
	asm{mov bx, centery}				\
	asm{sub ax, bx}						\
	asm{mov deltay, ax}					\
	deltaymulSINE2 = deltay * SINE2;	\
	deltaymulCOSINE2 = deltay * COSINE2;\
	ymul320 = (y << 8) + (y << 6);

	const int xsize = pic[0], ysize = pic[1];
	int px[4], py[4], minx, miny, maxx, maxy;
	int deltax, deltay, n, tmp, rotx, roty, x, y;
	const int SINE = sin(ang) * 256 * (scale + !scale);
	const int COSINE = cos(ang) * 256 * (scale + !scale);
	const int SINE2 = sin(-ang) * 256 / (scale + !scale);
	const int COSINE2 = cos(-ang) * 256 / (scale + !scale);
	int deltaymulSINE2, deltaymulCOSINE2, ymul320;

	scale += !scale;   /**** prevents division by zero ******/

	px[2] = px[0] = -xoffset;
	py[1] = py[0] = -yoffset;
	px[1] = px[3] = px[0] + xsize;
	py[2] = py[3] = py[0] + ysize;

	for(n = 0; n < 4; n++){
		tmp = (px[n] * COSINE - py[n] * SINE) >> 8;
		py[n] = (px[n] * SINE + py[n] * COSINE) >> 8;
		px[n] = tmp;
		px[n] += centerx;
		py[n] += centery;

		if(px[n] < minx || !n) minx = px[n];
		if(py[n] < miny || !n) miny = py[n];
		if(px[n] > maxx || !n) maxx = px[n];
		if(py[n] > maxy || !n) maxy = py[n];
	}

	if(minx < 0) minx = 0;		if(maxx < 0) maxx = 0;
	if(miny < 0) miny = 0;		if(maxy < 0) maxy = 0;
	if(minx > 319) minx = 319;	if(maxx > 319) maxx = 319;
	if(miny > 199) miny = 199;	if(maxy > 199) maxy = 199;

	maxx++; /* The ++'s here let me use a < comaprison in the for loops, */
	maxy++; /* rather than a <=, which is a tad slower. */

	switch(mode){
		case 0:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						vmem[x + ymul320] = pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 1:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						vmem[x + ymul320] ^= pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 2:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						vmem[x + ymul320] |= pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 3:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						vmem[x + ymul320] &= pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 4:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						if(pic[2 + rotx + xsize * roty])
							vmem[x + ymul320] = pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 5:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						if(!vmem[x + ymul320])
							vmem[x + ymul320] = pic[2 + rotx + xsize * roty];
					}
				}
			}
			break;

		case 6:
			for(y = miny; y < maxy; y++){
				HANDLE_MATH_IN_Y_LOOP
				for(x = minx; x < maxx; x++){
					HANDLE_MATH_IN_X_LOOP
					if(rotx >= 0 && rotx < xsize && roty >= 0 && roty < ysize){
						vmem[x + ymul320] += pic[2 + rotx + xsize * roty];
					}
				}
			}

	}
#undef HANDLE_MATH_IN_Y_LOOP
#undef HANDLE_MATH_IN_X_LOOP
}

void erase(int x1, int y1, int x2, int y2, int xoffset, int yoffset, unsigned char far *pic){
	int x, y, cx, cy, ymul320, xpicsize = pic[0], ypicsize = pic[1];

	if(x1 > x2) { x1 ^= x2; x2 ^= x1; x1 ^= x2; }
	if(y1 > y2) { y1 ^= y2; y2 ^= y1; y1 ^= y2; }

	if(y1 < 0) y1 = 0;
	if(y2 < 0) y2 = 0;
	if(y1 > 199) y1 = 199;
	if(y2 > 199) y2 = 199;
	if(x1 < 0) x1 = 0;
	if(x2 < 0) x2 = 0;
	if(x1 > 319) x1 = 319;
	if(x2 > 319) x2 = 319;


	for(y = y1; y <= y2; y++){
		cy = (y + yoffset) % ypicsize;
		ymul320 = (y << 8) + (y << 6);

		for(x = x1; x <= x2; x++){
			cx = (x + xoffset) % xpicsize;
			vmem[ymul320 + x] = pic[cx + xpicsize * cy + 2];
		}
	}
}

/****************************** File I/O ******************************/
unsigned char *loadptrpic(unsigned char *filename){
	unsigned char *pic = NULL;
	int size, xsize, ysize;
	FILE *picfile;
	picfile = fopen(filename, "rb");

	if(picfile){
		xsize = fgetc(picfile);
		ysize = fgetc(picfile);
		size = xsize * ysize + 2;
		pic = (unsigned char *)malloc(size);
		if(pic){
			pic[0] = xsize;
			pic[1] = ysize;
			size -= 2;
			fread((void *)&pic[2], 1, size, picfile);
		}
		fclose(picfile);
	}
	return pic;
}
