#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>

typedef struct{
	int x, y;
}vectortype;

/*======= Declarations =========*/
void erase(int x1, int y1, int x2, int y2);
char touching(int x1, int y1, char *pic1, int x2, int y2, char *pic2, char mode);
void cls(void);
char load_font(unsigned char *name);
void unload_font(void);
void save_font(unsigned char *name);
void drawtext(int x, int y, unsigned char *string, char mode);
void loadpic(char far *image, int arraysize, unsigned char *filename);
void savepic(char far *image, int arraysize, unsigned char *filename);
void circle(int cx, int cy, int radius, char mode, char colour);
void put(int x1, int y1, char far *picture, char mode);
void get(int x1, int y1, int x2, int y2, char far *picture);
void box(int x1, int y1, int x2, int y2, int colour, char mode);
void line(int x1, int y1, int x2, int y2, char colour, char mode);
int getpixel(int x, int y);
int sgn(int val);
void putpixel(int x, int y, char colour, char mode);
void locate(int x, int y);
int mousex(void);
int mousey(void);
void showmouse(int onoff);
void initmouse(void);
int buttonpressed(void);
void turnoffmcga(void);
void initmcga(void);
void readmousediff(void);
char blackcharstatus(void);
void setmousepos(int x, int y);
void setmouselimits(int x1, int y1, int x2, int y2);
char turnoffmouse(void);
void palette(char c, char r, char g, char b);
char kbscan(void);
unsigned long int counter(void);
char menuscreen(char *title, char *background, int numoptions, ...);
char choice(char *title, int numoptions, ...);
void readpalette(char c, char *r, char *g, char *b);
char readbit(FILE *fin);

/*======= Global Variables / Constants / Types =========*/
const int BACKGSIZE = 2000;
union REGS inregs, outregs;
unsigned char far *vmem = (unsigned char far *)0xA0000000;
vectortype mousediff;
char *font[256], *backg;
char xfontsize, yfontsize, done = 0;

void main(void){
	const int numpoints = 10, chunksize = 20;
	float *x, *y;
	int *oldx, *oldy;
	int a, b, n;
	float slope, dist;
	x = (float *)malloc(4 * numpoints);
	y = (float *)malloc(4 * numpoints);
	oldx = (int *)malloc(2 * numpoints);
	oldy = (int *)malloc(2 * numpoints);
	if(x && y && oldx && oldy){
		initmcga();
		initmouse();
		a = mousex();
		b = mousey();
		for(n = 0; n < numpoints; n++){
			x[n] = a + n * (sqrt((chunksize * chunksize) / 2));
			y[n] = b + n * (sqrt((chunksize * chunksize) / 2));
		}
		for(n = 1; n < numpoints; n++)
			line(x[n], y[n], x[n + 1], y[n + 1], 0, 0);

		showmouse(1);
		showmouse(0);
		while(!buttonpressed()){
			oldx[0] = x[0];
			oldy[0] = y[0];
			x[0] = mousex();
			y[0] = mousey();

			for(n = 1; n < numpoints; n++){
				dist = sqrt(abs((x[n] - x[n - 1]) * (x[n] - x[n - 1]) + (y[n] - y[n - 1]) * (y[n] - y[n - 1])));
				if(dist != 0){
					slope = (float)chunksize / dist;
					oldy[n] = y[n];
					oldx[n] = x[n];
					x[n] = - slope * (x[n - 1] - x[n]) + x[n - 1];
					y[n] = - slope * (y[n - 1] - y[n]) + y[n - 1];
				}
				line(oldx[n], oldy[n], oldx[n - 1], oldy[n - 1], 0, 0);
				line(x[n], y[n], x[n - 1], y[n - 1], 12, 0);
			}
		}
		turnoffmcga();
	}
	if(x) free(x);
	if(y) free(y);
	if(oldx) free(oldx);
	if(oldy) free(oldy);
}

void kill_keyboard_delay(void){
	int86(0x9, &inregs, &outregs);
}

unsigned char readkbd(void){
	char returnval = NULL;
	if(!kbhit()) kill_keyboard_delay();
	returnval = getch();
	return returnval;
}

char readbit(FILE *fin){
	char returnval = 0;
	static unsigned char byte, bitsleft = 0;


	if(!feof(fin) || bitsleft){
		if(bitsleft == 0){
			byte = fgetc(fin);
			bitsleft = 8;
		}

		bitsleft--;
		if(byte >= pow(2, bitsleft)){
			byte -= pow(2, bitsleft);
			returnval = 1;
		}
		return returnval;
	}else{
		return -1;
	}


}

char blackcharstatus(void){
	inregs.h.ah = 0x0002;
	int86(0x00020016, &inregs, &outregs);
	return outregs.h.al;
}

void readmousediff(void){
	inregs.x.ax = 0x0B;
	int86(0x000B0033, &inregs, &outregs);
	mousediff.x = outregs.x.cx;
	mousediff.y = outregs.x.dx;
}

void initmcga(void){
	union REGS regs;
	regs.h.ah = 0x0;
	regs.h.al = 0x13;
	int86(0x10, &regs, &regs);
}

void turnoffmcga(void){
	int n;
	union REGS regs;
	regs.h.ah = 0x0;
	regs.h.al = 0x3;
	int86(0x10, &regs, &regs);

	for(n = 0; n < 256; n++)
		if(font[n]){
			free(font[n]);
			font[n] = NULL;
		}

}

int buttonpressed(void){
	inregs.x.ax = 3;
	int86(0x00030033, &inregs, &outregs);
	return(outregs.x.bx);
}


int mousex(void){
	inregs.x.ax = 3;
	int86(0x00030033, &inregs, &outregs);
	return (int)(outregs.x.cx / 2);
}

int mousey(void){
	inregs.x.ax = 3;
	int86(0x00030033, &inregs, &outregs);
	return(outregs.x.dx);
}

void initmouse(void){
	inregs.x.ax = 0;
	int86(0x00030033, &inregs, &outregs);
}

void showmouse(int onoff){
	if(onoff) inregs.x.ax = 1;
	else inregs.x.ax = 2;
	int86(0x00030033, &inregs, &outregs);
}

void locate(int x, int y){
   union REGS regs;
   regs.h.ah = 2;
   regs.h.dh = y;
   regs.h.dl = x;
   regs.h.bh = 0;
   int86(0x10, &regs, &regs);
}

void putpixel(int x, int y, char colour, char mode){
	if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
		switch(mode){
			case 0: vmem[(y << 8) + (y << 6) + x]  = colour; break;
			case 1: vmem[(y << 8) + (y << 6) + x] ^= colour; break;
			case 2: vmem[(y << 8) + (y << 6) + x] |= colour; break;
			case 3: vmem[(y << 8) + (y << 6) + x] &= colour; break;
			case 4:
				if(colour) vmem[(y << 8) + (y << 6) + x] = colour;
				break;
			case 5:
				if(!vmem[(y << 8) + (y << 6) + x])
					vmem[(y << 8) + (y << 6) + x] = colour;
				break;
		}
}

int getpixel(int x, int y){
	if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
		return vmem[x + y * 320];
	else
		return 0;
}

int sgn(int val){
	if(val > 0) return 1;
	return -(val < 0);
}

void line(int x1, int y1, int x2, int y2, char colour, char mode){
	int i, dx, dy, sdx, sdy, dxabs, dyabs, x, y, px, py;

	dx = x2 - x1;
	dy = y2 - y1;
	dxabs = abs(dx);
	dyabs = abs(dy);
	sdx = sgn(dx);
	sdy = sgn(dy);
	x = dyabs >> 1;
	y = dxabs >> 1;
	px = x1;
	py = y1;

	putpixel(px, py, colour, mode);

	if (dxabs >= dyabs){
		for(i = 0; i < dxabs; i++){
			y += dyabs;
			if (y >= dxabs){
				y -= dxabs;
				py += sdy;
			}
			px += sdx;
			putpixel(px, py, colour, mode);
		}
	}else{
		for(i = 0; i < dyabs; i++){
			x += dxabs;
			if(x >= dyabs){
				x -= dyabs;
				px += sdx;
			}
			py += sdy;
			putpixel(px, py, colour, mode);
		}
	}
}

void box(int x1, int y1, int x2, int y2, int colour, char mode){
	int x, y;
	if(x1 < 0) x1 = 0; if(x1 > 319) x1 = 319;
	if(y1 < 0) y1 = 0; if(y1 > 199) y1 = 199;
	if(x2 < 0) x2 = 0; if(x2 > 319) x2 = 319;
	if(y2 < 0) y2 = 0; if(y2 > 199) y2 = 199;
	if(x1 > x2) { x1 ^= x2; x2 ^= x1; x1 ^= x2; }
	if(y1 > y2) { y1 ^= y2; y2 ^= y1; y1 ^= y2; }

	if(mode == 4){
		for(x = x1; x <= x2; x++){
			vmem[x + 320 * y1] = colour;
			vmem[x + 320 * y2] = colour;
		}
		for(y = y1; y <= y2; y++){
			vmem[x1 + 320 * y] = colour;
			vmem[x2 + 320 * y] = colour;
		}

	}
	else{
		for(x = x1; x <= x2; x++){
			for(y = y1; y <= y2; y++){
				switch(mode){
					case 0: vmem[x + 320 * y]  = colour; break;
					case 1:	vmem[x + 320 * y] ^= colour; break;
					case 2: vmem[x + 320 * y] |= colour; break;
					case 3: vmem[x + 320 * y] &= colour; break;
					case 5:
						vmem[x + 320 * y] += (!vmem[x + 320 * y]) * colour;
					break;
					case 6: vmem[x + 320 * y] += colour; break;
				}
			}
		}
	}
}

void circle(int cx, int cy, int radius, char mode, char colour){
	int ydist, ydist2, xdist, x, y, dx2;
	int x1;
	if(radius < 1) radius *= -1;
	if(!radius) radius++;
	x1 = cx - radius;
	for(x = x1; x <= cx; x += 1){
		xdist = abs(x - cx);
		ydist = sqrt(radius * radius - xdist * xdist);
		ydist2 = sqrt(radius * radius - (xdist - 1) * (xdist - 1));
		ydist2 += !xdist;
		if(mode == 4){
			if(abs(ydist2 - ydist) > 1){
				for(y = ydist; y < ydist2; y++){
					if((x >= 0) && (x <= 319)){
						if((cy + y >= 0) && (cy + y <= 199)) vmem[x + 320 * (cy + y)] = colour;
						if((cy - y >= 0) && (cy - y <= 199)) vmem[x + 320 * (cy - y)] = colour;
					}
					dx2 = cx + xdist;
					if((dx2 >= 0) && (dx2 <= 319)){
						if((cy + y >= 0) && (cy + y <= 199)) vmem[dx2 + 320 * (cy + y)] = colour;
						if((cy - y >= 0) && (cy - y <= 199)) vmem[dx2 + 320 * (cy - y)] = colour;
					}
				}
			}else{
				dx2 = cx + xdist;
				y = cy + ydist;
				if((y >= 0) && (y <= 199)){
					if((x >= 0) && (x <= 319)) vmem[x + 320 * y] = colour;
					if((dx2 >= 0) && (dx2 <= 319)) vmem[dx2 + 320 * y] = colour;
				}
				y = cy - ydist;
				if((y >= 0) && (y <= 199)){
					if((x >= 0) && (x <= 319)) vmem[x + 320 * y] = colour;
					if((dx2 >= 0) && (dx2 <= 319)) vmem[dx2 + 320 * y] = colour;
				}
			}
		}else{
			box(x, cy + ydist2, x, cy - ydist2, colour, mode);
			dx2 = cx + xdist;
			if(xdist > 0)box(dx2, cy + ydist2, dx2, cy - ydist2, colour, mode);
		}
	}
}

unsigned long int counter(void){
	/**** accurate to .1 seconds ****/
	return peek(0x40, 0x6C);
}

char kbscan(void){
	return inp(0x60);
}

void palette(char c, char r, char g, char b){
	inregs.h.ah = 0x10;
	inregs.h.al = 0x10;
	inregs.x.bx = c;
	inregs.h.ch = g % 64;
	inregs.h.cl = b % 64;
	inregs.h.dh = r % 64;
	int86(0x00100010, &inregs, &outregs);
}

char turnoffmouse(void){
	inregs.x.ax = 0x1F;
	int86(0x001F0033, &inregs, &outregs);
	return outregs.x.ax;
}

void setmousepos(int x, int y){
	inregs.x.ax = 4;
	inregs.x.cx = x * 2;
	inregs.x.dx = y;
	int86(0x00040033, &inregs, &outregs);
}

void setmouselimits(int x1, int y1, int x2, int y2){
	inregs.x.ax = 7;
	inregs.x.cx = x1 * 2;
	inregs.x.dx = x2 * 2;
	int86(0x00070033, &inregs, &outregs);
	inregs.x.ax = 8;
	inregs.x.cx = y1;
	inregs.x.dx = y2;
	int86(0x00080033, &inregs, &outregs);
}

void cls(void){
	_fmemset(vmem, 0, 64000);
}

void drawtext(int x, int y, unsigned char *string, char mode){
	int length = strlen(string), n, m, initx = x;
	char charval, junk[100], doneonce, c;

	for(n = 0; n < length; n++){
		charval = string[n];
		if(charval == '/'){
			charval = NULL;
			doneonce = 0;
			while(charval == NULL){
				n++;
				c = string[n];
				switch(c){
					case 'n': x = initx; y += yfontsize; doneonce = 1; break;
					case 't': x += 4 * xfontsize; doneonce = 1; break;
					case '/':
						if(!doneonce)
							charval = '/';
						doneonce = 0;
					break;
					case 'v': case 'h':
						m = 0;
						junk[0] = NULL;

						do{
							n++;
							if(string[n] != '/'){
								junk[strlen(junk) + 1] = NULL;
								junk[strlen(junk)] = string[n];
								m++;
							}
						}while(string[n] != '/' && m < 100);
						if(c == 'v'){
							m = yfontsize * atoi(junk);
							y += m;
						}else{
							m = xfontsize * atoi(junk);
							x += m;
						}
						doneonce = 1;
					break;
					default:
						charval = string[n];
					break;
				}
			}
		}
		put(x, y, font[charval], mode);
		x += xfontsize;
	}
}

void save_font(unsigned char *name){
	int c, n;
	FILE *fname;
	fname = fopen(name, "w");

	fputc(xfontsize, fname);
	fputc(yfontsize, fname);

	for(c = 0; c < 256; c++){
		for(n = 2; n < (xfontsize * yfontsize + 2); n++){
			fputc(font[c][n], fname);
		}
	}

	fclose(fname);

}

void unload_font(void){
	int n;
	for(n = 0; n < 256; n++)
		if(font[n]){
			free(font[n]);
			font[n] = NULL;
		}
}

char load_font(unsigned char *name){
	int c, n, bad = 0;
	FILE *fname;
	fname = fopen(name, "r");

	xfontsize = fgetc(fname);
	yfontsize = fgetc(fname);

	for(n = 0; (n < 256) && !bad; n++){
		if(font[n]) free(font[n]);
		bad = (font[n] = (char *)malloc(xfontsize * yfontsize + 2)) == NULL;
	}

	for(c = 0; (c < 256) && !bad; c++){
		font[c][0] = xfontsize;
		font[c][1] = yfontsize;
		for(n = 2; n < (xfontsize * yfontsize + 2); n++){
			font[c][n] = fgetc(fname);
		}
	}
	fclose(fname);

	for(n = 0; (n < 256) && bad; n++)
		if(font[n]){
			free(font[n]);
			font[n] = NULL;
		}

	return (bad == 0);
}

void get(int x1, int y1, int x2, int y2, char far *picture){
	int n = 2, x, y;
	if(x1 > x2){ x1 ^= x2; x2 ^= x1; x1 ^= x2; }
	if(y1 > y2){ y1 ^= y2; y2 ^= y1; y1 ^= y2; }

	picture[0] = x2 - x1 + 1;
	picture[1] = y2 - y1 + 1;
	for(y = y1; y <= y2; y++){
		for(x = x1; x <= x2; x++){
			if((x >= 0) || (x <= 319) || (y >= 0) || (y <= 199))
				picture[n] = vmem[x + y * 320];
			else
				picture[n] = 0;

			n++;
		}
	}
}

void put(int x1, int y1, char far *picture, char mode){
	int n = 2, x, y;
	int x2 = x1 + picture[0] - 1;
	int y2 = y1 + picture[1] - 1;

	switch(mode){
		case 0:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[x + y * 320]  = picture[n];
					n++;
				}
		break;
		case 1:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[x + y * 320] ^= picture[n];
					n++;
				}
		break;
		case 2:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[x + y * 320] |= picture[n];
					n++;
				}
		break;
		case 3:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[x + y * 320] &= picture[n];
					n++;
				}
		break;
		case 4:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if(picture[n] != 0)
						if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
							vmem[x + y * 320] = picture[n];
					n++;
				}
		break;

		case 5:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						if(vmem[x + y * 320] == 0)
							vmem[x + y * 320] = picture[n];
					n++;
				}
		break;
	}
}

void savepic(char far *image, int arraysize, unsigned char *filename){
	int n;
	FILE *picfile;
	picfile = fopen(filename, "wb");

	for(n = 0; (n < arraysize) && (n < (image[0] * image[1] + 2)); n++)
		fputc((unsigned char)image[n] , picfile);

	fclose(picfile);
}

void loadpic(char far *image, int arraysize, unsigned char *filename){
	int gotall = 0, n;
	FILE *picfile;
	picfile = fopen(filename, "rb");

	for(n = 0; (n < arraysize) && (!gotall); n++){
		image[n] = fgetc(picfile);
		if(n >= 1) gotall = (n >= (image[0] * image[1] + 2)) || feof(picfile);
	}
	fclose(picfile);
}

void erase(int x1, int y1, int x2, int y2){
	int x, y, cx, cy;

	for(x = x1; x <= x2; x++){
		for(y = y1; y <= y2; y++){
			cx = x % backg[0];
			cy = y % backg[1];
			if((x <= 319) && (x >= 0) && (y <= 199) && (y >= 0))
				vmem[x + 320 * y] = backg[cx + backg[0] * cy + 2];
		}
	}
}

char touching(int x1, int y1, char *pic1, int x2, int y2, char *pic2, char mode){
	int x, y;
	char returnval = 0;

	if((x1 >= x2 - pic1[0]) &&
	  (x1 <= x2 + pic2[0]) &&
	  (y1 >= y2 - pic1[1]) &&
	  (y1 <= y2 + pic2[1]))
	{
		if(!mode) returnval = 1;
		else{
			for(x = x1; x < x1 + pic1[0]; x++){
				for(y = y1; y < y1 + pic1[1]; y++){
					if((x >= x2) && (x <= x2 + pic2[0] - 1) &&
					  (y >= y2) && (y <= y2 + pic2[1] - 1))
					{
						if(
						  pic1[2 + x - x1 + 1 + pic1[0] * (y - y1)] &&
						  pic2[2 + x - x2 + 1 + pic2[0] * (y - y2)]

						)
						returnval = 1;
					}
				}
			}

		}

	}else
		returnval = 0;

	return returnval;
}

char choice(char *title, int numoptions, ...){
	int n, x1[50], x2[50], y1[50], y2[50], tx, ty, mx, my;
	int bx1, by1, bx2, by2;
	char *option[50], fini = 0, copt = 0, returnval;
	char underpointer[122], pointer[122], option_chosen = -1;
	va_list ap;

	va_start(ap, numoptions);
	for(n = 0; n < numoptions; n++){
		option[n] = va_arg(ap, char *);
	}
	va_end(ap);
	loadpic(pointer, 122, "POINTER.PIC");


	/********* draw the title **********/
	tx = 160 - (xfontsize * strlen(title)) / 2;
	ty = 100 - 2 * yfontsize;

	x1[0] = 160;
	for(n = 0; n < numoptions; n++)
		x1[0] -= (option[n][0] + 10) / 2;
	x2[0] = x1[0] + option[0][0] - 1;
	y1[0] = 100 - option[0][1] / 2 + 2 * yfontsize;
	y2[0] = y1[0] + option[0][1] - 1;

	for(n = 1; n < numoptions; n++){
		x1[n] = x2[n - 1] + 10;
		x2[n] = x1[n] + option[n][0] - 1;
		y1[n] = 100 - option[n][1] / 2 + 2 * yfontsize;
		y2[n] = y1[n] + option[n][1] - 1;
	}

	bx1 = tx - 10;
	bx2 = tx + strlen(title) * xfontsize + 10;
	by1 = ty - 10;
	by2 = ty + yfontsize;
	for(n = 0; n < numoptions; n++){
		if(x1[n] - 10 < bx1) bx1 = x1[n] - 10;
		if(x2[n] + 10 > bx2) bx2 = x2[n] + 10;
		if(y1[n] - 10 < by1) by1 = y1[n] - 10;
		if(y2[n] + 10 > by2) by2 = y2[n] + 10;
	}

	box(bx1 - 1, by1 - 1, bx2, by2, 22, 4);
	box(bx1, by1, bx2 + 1, by2 + 1, 18, 4);
	box(bx1, by1, bx2, by2, 20, 0);

	drawtext(tx, ty, title, 4);
	for(n = 0; n < numoptions; n++)
		put(x1[n], y1[n], option[n], 0);


	while(kbhit()) getch();
	box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 14, 4);
	mx = mousex();
	my = mousey();
	get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
	while(!fini){
		/******** handle mouse IO **********/
		if(mx != mousex() || my != mousey()){
			put(mx, my, underpointer, 0);
			mx = mousex();
			my = mousey();
			for(n = 0; n < numoptions; n++){
				if(mx >= x1[n] && mx <= x2[n] && my >= y1[n] && my <= y2[n] && n != copt){
					box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 20, 4);
					copt = n;
					box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 14, 4);
				}
			}
			get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
			put(mx, my, pointer, 4);
		}
		option_chosen = -1;
		while(buttonpressed()){
			if(mx != mousex() || my != mousey()){
				put(mx, my, underpointer, 0);
				mx = mousex();
				my = mousey();
				get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
				put(mx, my, pointer, 4);
			}
			option_chosen = -1;
			for(n = 0; n < numoptions; n++){
				if(mx >= x1[n] && mx <= x2[n] && my >= y1[n] && my <= y2[n]){
					if(n != copt){
						put(mx, my, underpointer, 0);
						box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 20, 4);
						copt = n;
						box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 14, 4);
						get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						put(mx, my, pointer, 4);
					}
					option_chosen = n;
				}
			}
		}
		if(option_chosen != -1){
			returnval = option_chosen;
			fini = 1;
		}

		/******** handle keyboard IO ********/
		if(kbhit()){
			switch(getch()){
				case 13:
					returnval = copt;
					fini = 1;
				break;
				case 0:
					switch(getch()){
						case 'H': case 'K':
							put(mx, my, underpointer, 0);
							box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 20, 4);
							copt--;
							if(copt < 0) copt += numoptions;
							box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 14, 4);
							get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						break;
						case 'M': case 'P':
							put(mx, my, underpointer, 0);
							box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 20, 4);
							copt = (copt + 1) % numoptions;
							box(x1[copt] - 1, y1[copt] - 1, x2[copt] + 1, y2[copt] + 1, 14, 4);
							get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						break;
					}
				break;
			}
		}
	}
	put(mx, my, underpointer, 0);
	return returnval;
}

char menuscreen(char *title, char *background, int numoptions, ...){
	int n, x1[50], x2[50], y1[50], y2[50], tx, ty, mx, my;
	char *option[50], fini = 0, copt = 0, returnval;
	char underpointer[122], option_chosen = -1;
	char pointer[122];
	va_list ap;

	loadpic(pointer, 122, "POINTER.PIC");
	va_start(ap, numoptions);
	for(n = 0; n < numoptions; n++){
		option[n] = va_arg(ap, char *);
	}
	va_end(ap);

	loadpic(backg, BACKGSIZE, background);
	erase(0, 0, 319, 199);

	/********* draw the title **********/
	tx = 160 - (xfontsize * strlen(title)) / 2;
	ty = 15;
	box(tx - 24, ty - 9, tx + 26+ strlen(title) * xfontsize - 1, ty + 11 + yfontsize - 1, 16, 0);
	box(tx - 26, ty - 11, tx + 24 + strlen(title) * xfontsize - 1, ty + 9 + yfontsize - 1, 20, 0);
	box(tx - 25, ty - 10, tx + 25 + strlen(title) * xfontsize - 1, ty + 10 + yfontsize - 1, 18, 0);
	drawtext(tx, ty, title, 4);

	for(n = 0; n < numoptions; n++){
		x1[n] = 160 - (strlen(option[n]) * xfontsize) / 2 - xfontsize / 2;
		x2[n] = x1[n] + strlen(option[n]) * xfontsize + xfontsize;
		y1[n] = 130 + (n - (numoptions / 2)) * 2 * yfontsize - yfontsize / 3;
		y2[n] = y1[n] + yfontsize + 2 * yfontsize / 3;
		box(x1[n] + 1, y1[n] + 1, x2[n], y2[n], 18, 0);
		box(x1[n], y1[n], x2[n] - 1, y2[n] - 1, 26, 0);
		box(x1[n] + 1, y1[n] + 1, x2[n] - 1, y2[n] - 1, 22, 0);
		drawtext(x1[n] + xfontsize / 2, y1[n] + yfontsize / 3, option[n], 4);

	}

	while(kbhit()) getch();
	box(x1[copt], y1[copt], x2[copt], y2[copt], 4, 6);
	mx = mousex();
	my = mousey();
	get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
	while(!fini){
		/******** handle mouse IO **********/
		if(mx != mousex() || my != mousey()){
			put(mx, my, underpointer, 0);
			mx = mousex();
			my = mousey();
			for(n = 0; n < numoptions; n++){
				if(mx >= x1[n] && mx <= x2[n] && my >= y1[n] && my <= y2[n] && n != copt){
					box(x1[copt], y1[copt], x2[copt], y2[copt], -4, 6);
					copt = n;
					box(x1[copt], y1[copt], x2[copt], y2[copt], 4, 6);
				}
			}
			get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
			put(mx, my, pointer, 4);
		}
		option_chosen = -1;
		while(buttonpressed()){
			if(mx != mousex() || my != mousey()){
				put(mx, my, underpointer, 0);
				mx = mousex();
				my = mousey();
				get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
				put(mx, my, pointer, 4);
			}
			option_chosen = -1;
			for(n = 0; n < numoptions; n++){
				if(mx >= x1[n] && mx <= x2[n] && my >= y1[n] && my <= y2[n]){
					if(n != copt){
						put(mx, my, underpointer, 0);
						box(x1[copt], y1[copt], x2[copt], y2[copt], -4, 6);
						copt = n;
						box(x1[copt], y1[copt], x2[copt], y2[copt], 4, 6);
						get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						put(mx, my, pointer, 4);
					}
					option_chosen = n;
				}
			}
		}
		if(option_chosen != -1){
			returnval = option_chosen;
			fini = 1;
		}

		/******** handle keyboard IO ********/
		if(kbhit()){
			switch(getch()){
				case 13:
					returnval = copt;
					fini = 1;
				break;
				case 0:
					switch(getch()){
						case 'H': case 'K':
							put(mx, my, underpointer, 0);
							box(x1[copt], y1[copt], x2[copt], y2[copt], -4, 6);
							copt--;
							if(copt < 0) copt += numoptions;
							box(x1[copt], y1[copt], x2[copt], y2[copt], 4, 6);
							get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						break;
						case 'M': case 'P':
							put(mx, my, underpointer, 0);
							box(x1[copt], y1[copt], x2[copt], y2[copt], -4, 6);
							copt = (copt + 1) % numoptions;
							box(x1[copt], y1[copt], x2[copt], y2[copt], 4, 6);
							get(mx, my, mx + pointer[0] - 1, my + pointer[1] - 1, underpointer);
						break;
					}
				break;
			}
		}
	}
	put(mx, my, underpointer, 0);
	return returnval;
}

